Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -1362,7 +1129,7 @@ static png_free_ptr png_IM_free(png_stru
 }
 #endif
 
-static int
+static MagickPassFail
 png_read_raw_profile(Image *image, const ImageInfo *image_info,
                      png_textp text,int ii)
 {
@@ -1408,15 +1175,15 @@ png_read_raw_profile(Image *image, const
   if (length == 0)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "invalid profile length");
-      return (False);
+          "invalid profile length");
+      return (MagickFail);
     }
   info=MagickAllocateMemory(unsigned char *,length);
   if (info == (unsigned char *) NULL)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "Unable to copy profile");
-      return (False);
+          "Unable to copy profile");
+      return (MagickFail);
     }
   /* copy profile, skipping white space and column 1 "=" signs */
   dp=info;
@@ -1427,10 +1194,10 @@ png_read_raw_profile(Image *image, const
         {
           if (*sp == '\0')
             {
-              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                    "ran out of profile data");
               MagickFreeMemory(info);
-              return (False);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "ran out of profile data");
+              return (MagickFail);
             }
           sp++;
         }
@@ -1449,13 +1216,16 @@ png_read_raw_profile(Image *image, const
   else if (!memcmp(&text[ii].key[17], "icm\0",4))
     {
       strlcpy(profile_name,"ICM",sizeof(profile_name));
-      strlcpy(profile_description,"ICM (ICCP) profile.",sizeof(profile_description));
+      strlcpy(profile_description,"ICM (ICCP) profile.",
+              sizeof(profile_description));
     }
   else
     {
       strlcpy(profile_name,&text[ii].key[17],sizeof(profile_name));
-      strlcpy(profile_description,"generic profile, type ",sizeof(profile_description));
-      strlcat(profile_description,&text[ii].key[17],sizeof(profile_description));
+      strlcpy(profile_description,"generic profile, type ",
+              sizeof(profile_description));
+      strlcat(profile_description,&text[ii].key[17],
+              sizeof(profile_description));
     }
   if (image_info->verbose)
     (void) printf(" Found a %.1024s\n",profile_description);
@@ -1463,13 +1233,144 @@ png_read_raw_profile(Image *image, const
     {
       MagickFreeMemory(info);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "unable to copy profile");
-      return (False);
+           "unable to copy profile");
+      return MagickFail;
     }
   MagickFreeMemory(info);
-  return True;
+  return MagickTrue;
 }
 
+#if defined(PNG_UNKNOWN_CHUNKS_SUPPORTED)
+
+static int read_user_chunk_callback(png_struct *ping, png_unknown_chunkp chunk)
+{
+  Image
+    *image;
+
+
+  /* The unknown chunk structure contains the chunk data:
+     png_byte name[5];
+     png_byte *data;
+     png_size_t size;
+
+     Note that libpng has already taken care of the CRC handling.
+
+     Returns one of the following:
+         return(-n);  chunk had an error
+         return(0);  did not recognize
+         return(n);  success
+  */
+
+  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+     "    read_user_chunk: found %c%c%c%c chunk",
+       chunk->name[0],chunk->name[1],chunk->name[2],chunk->name[3]);
+
+  if (chunk->name[0]  == 101 &&
+      (chunk->name[1] ==  88 || chunk->name[1] == 120 ) &&
+      chunk->name[2]  ==  73 &&
+      chunk->name[3]  == 102)
+    {
+      /* process eXIf or exIf chunk */
+
+      unsigned char
+        *profile;
+
+      unsigned char
+        *p;
+
+      png_byte
+        *s;
+
+      size_t
+        i;
+
+(void) LogMagickEvent(CoderEvent,GetMagickModule(),
+        " recognized eXIf chunk");
+
+      image=(Image *) png_get_user_chunk_ptr(ping);
+
+#if PNG_LIBPNG_VER >= 14000
+      profile=(unsigned char *) png_malloc(ping,
+        (png_alloc_size_t) chunk->size+6);
+#else
+      profile=(unsigned char *) png_malloc(ping,
+         (png_size_t) chunk->size+6);
+#endif
+      p=profile;
+
+      if (*p != 'E' || *(p+1) != 'x' || *(p+2) != 'i' ||
+          *(p+3) != 'f' || *(p+4) != '\0' || *(p+5) != '\0')
+        {
+          /* Initialize profile with "Exif\0\0" if it
+             doesn't already begin with it by accident
+          */
+          *p++ ='E';
+          *p++ ='x';
+          *p++ ='i';
+          *p++ ='f';
+          *p++ ='\0';
+          *p++ ='\0';
+        }
+
+      /* copy chunk->data to profile */
+      s=chunk->data;
+      for (i=0; i<chunk->size; i++)
+        *p++ = *s++;
+
+      (void) SetImageProfile(image,"exif",
+         (const unsigned char *)profile, chunk->size+6);
+      return(1);
+    }
+
+  /* orNT */
+  if (chunk->name[0] == 111 &&
+      chunk->name[1] == 114 &&
+      chunk->name[2] ==  78 &&
+      chunk->name[3] ==  84)
+    {
+     /* recognized orNT */
+     if (chunk->size != 1)
+       return(-1); /* Error return */
+
+     image=(Image *) png_get_user_chunk_ptr(ping);
+     if (chunk->data[0] < 9)
+       image->orientation = chunk->data[0];
+     else
+       image->orientation = 0;
+     return(1);
+    }
+
+  /* caNv */
+  if (chunk->name[0] ==  99 &&
+      chunk->name[1] ==  97 &&
+      chunk->name[2] ==  78 &&
+      chunk->name[3] == 118)
+    {
+     /* recognized caNv */
+
+     if (chunk->size != 16)
+       return(-1); /* Error return */
+
+     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             " recognized caNv chunk");
+
+     image=(Image *) png_get_user_chunk_ptr(ping);
+
+     image->page.width=(size_t) mng_get_long(chunk->data);
+     image->page.height=(size_t) mng_get_long(&chunk->data[4]);
+     image->page.x=(size_t) mng_get_long(&chunk->data[8]);
+     image->page.y=(size_t) mng_get_long(&chunk->data[12]);
+
+     return(1);
+    }
+
+  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+         " unrecognized user chunk");
+
+  return(0); /* Did not recognize */
+}
+#endif /* PNG_UNKNOWN_CHUNKS_SUPPORTED */
+
 /*
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %                                                                             %
@@ -1505,7 +1406,8 @@ png_read_raw_profile(Image *image, const
 %
 */
 static Image *ReadOnePNGImage(MngInfo *mng_info,
-                              const ImageInfo *image_info, ExceptionInfo *exception)
+                              const ImageInfo *image_info,
+                              ExceptionInfo *exception)
 {
   /* Read one PNG image */
 
@@ -1516,11 +1418,25 @@ static Image *ReadOnePNGImage(MngInfo *m
     logging,
     num_text,
     num_passes,
-    pass;
+    pass,
+    ping_bit_depth,
+    ping_colortype,
+    ping_file_depth,
+    ping_interlace_method,
+    ping_compression_method,
+    ping_filter_method,
+    ping_num_trans;
 
-  PixelPacket
+  LongPixelPacket
     transparent_color;
 
+  png_bytep
+     ping_trans_alpha;
+
+  png_color_16p
+     ping_background,
+     ping_trans_color;
+
   png_info
     *end_info,
     *ping_info;
@@ -1528,18 +1444,17 @@ static Image *ReadOnePNGImage(MngInfo *m
   png_struct
     *ping;
 
+  png_uint_32
+    ping_rowbytes,
+    ping_width,
+    ping_height;
+
   png_textp
     text;
 
-  unsigned char
-    *png_pixels;
-
   long
     y;
 
-  register unsigned char
-    *p;
-
   register IndexPacket
     *indexes;
 
@@ -1563,22 +1478,29 @@ static Image *ReadOnePNGImage(MngInfo *m
       115,  67,  65,  76, '\0',   /* sCAL */
       115,  80,  76,  84, '\0',   /* sPLT */
       116,  73,  77,  69, '\0',   /* tIME */
+#ifdef PNG_APNG_SUPPORTED /* libpng was built with APNG patch; */
+                          /* ignore the APNG chunks */
+       97,  99,  84,  76, '\0',   /* acTL */
+      102,  99,  84,  76, '\0',   /* fcTL */
+      102, 100,  65,  84, '\0',   /* fdAT */
+#endif
     };
 #endif
 
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),
                          "  enter ReadOnePNGImage()");
 
-  transparent_color.red=0;
-  transparent_color.green=0;
-  transparent_color.blue=0;
-  transparent_color.opacity=0;
+  /* Set to an out-of-range color unless tRNS chunk is present */
+  transparent_color.red=65537;
+  transparent_color.green=65537;
+  transparent_color.blue=65537;
+  transparent_color.opacity=65537;
 
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
   AcquireSemaphoreInfo(&png_semaphore);
 #endif
 
-#if (PNG_LIBPNG_VER < 10007)
+#if (PNG_LIBPNG_VER < 10012)
   if (image_info->verbose)
     printf("Your PNG library (libpng-%s) is rather old.\n",
            PNG_LIBPNG_VER_STRING);
@@ -1592,37 +1514,36 @@ static Image *ReadOnePNGImage(MngInfo *m
 #ifdef PNG_USER_MEM_SUPPORTED
   ping=png_create_read_struct_2(PNG_LIBPNG_VER_STRING, image,
                                 PNGErrorHandler,PNGWarningHandler, NULL,
-                                (png_malloc_ptr) png_IM_malloc,(png_free_ptr) png_IM_free);
+                                (png_malloc_ptr) png_IM_malloc,
+                                (png_free_ptr) png_IM_free);
 #else
   ping=png_create_read_struct(PNG_LIBPNG_VER_STRING,image,
                               PNGErrorHandler,PNGWarningHandler);
 #endif
   if (ping == (png_struct *) NULL)
-    ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
-  ping_info=png_create_info_struct(ping);
-  if (ping_info == (png_info *) NULL)
     {
-      png_destroy_read_struct(&ping,(png_info **) NULL,(png_info **) NULL);
-      ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
-    }
-  end_info=png_create_info_struct(ping);
-  if (end_info == (png_info *) NULL)
-    {
-      png_destroy_read_struct(&ping,&ping_info,(png_info **) NULL);
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+      LiberateSemaphoreInfo(&png_semaphore);
+#endif
       ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
     }
-  png_pixels=(unsigned char *) NULL;
-  if (setjmp(ping->jmpbuf))
+
+  png_set_crc_action(ping, PNG_CRC_QUIET_USE, PNG_CRC_QUIET_USE);
+
+  mng_info->png_pixels=(unsigned char *) NULL;
+  mng_info->quantum_scanline=(Quantum *) NULL;
+
+  if (setjmp(png_jmpbuf(ping)))
     {
       /*
         PNG image is corrupt.
       */
       png_destroy_read_struct(&ping,&ping_info,&end_info);
+      MagickFreeMemory(mng_info->quantum_scanline);
+      MagickFreeMemory(mng_info->png_pixels);
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
       LiberateSemaphoreInfo(&png_semaphore);
 #endif
-      if (png_pixels != (unsigned char *) NULL)
-        MagickFreeMemory(png_pixels);
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "  exit ReadOnePNGImage() with error.");
@@ -1634,6 +1555,45 @@ static Image *ReadOnePNGImage(MngInfo *m
         }
       return(image);
     }
+
+/* { From here through end of ReadOnePNGImage(), use png_error(), not Throw() */
+
+  ping_info=png_create_info_struct(ping);
+  if (ping_info == (png_info *) NULL)
+    {
+      png_destroy_read_struct(&ping,(png_info **) NULL,(png_info **) NULL);
+      png_error(ping,"Could not allocate PNG info struct");
+    }
+
+  end_info=png_create_info_struct(ping);
+  if (end_info == (png_info *) NULL)
+    {
+      png_destroy_read_struct(&ping,&ping_info,(png_info **) NULL);
+      png_error(ping,"Could not allocate PNG end_info struct");
+    }
+
+#ifdef PNG_BENIGN_ERRORS_SUPPORTED
+  /* Allow benign errors */
+  png_set_benign_errors(ping, 1);
+#endif
+
+  /* Just use libpng's limit (PNG_USER_CHUNK_MALLOC_MAX == 8000000) on
+     chunk size */
+#ifdef PNG_SET_USER_LIMITS_SUPPORTED
+  /* Reject images with too many rows or columns */
+  png_set_user_limits(ping,
+    (png_uint_32) 0x7fffffffL,
+    (png_uint_32) 0x7fffffffL);
+#endif /* PNG_SET_USER_LIMITS_SUPPORTED */
+
+  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "    PNG width limit: %lu, height limit: %lu",
+    (unsigned long) 0x7fffffffL,
+    (unsigned long) 0x7fffffffL);
+  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "    PNG pixels limit: %lu",
+    (unsigned long) GetMagickResourceLimit(PixelsResource));
+
   /*
     Prepare PNG for reading.
   */
@@ -1645,16 +1605,16 @@ static Image *ReadOnePNGImage(MngInfo *m
       (void) png_permit_mng_features(ping,PNG_ALL_MNG_FEATURES);
       png_set_read_fn(ping,image,png_get_data);
 #else
-#if defined(PNG_READ_EMPTY_PLTE_SUPPORTED)
-      png_permit_empty_plte(ping,True);
+# if defined(PNG_READ_EMPTY_PLTE_SUPPORTED)
+      png_permit_empty_plte(ping,MagickTrue);
       png_set_read_fn(ping,image,png_get_data);
-#else
+# else
       mng_info->image=image;
       mng_info->bytes_in_read_buffer=0;
-      mng_info->found_empty_plte=False;
-      mng_info->have_saved_bkgd_index=False;
+      mng_info->found_empty_plte=MagickFalse;
+      mng_info->have_saved_bkgd_index=MagickFalse;
       png_set_read_fn(ping,mng_info,mng_get_data);
-#endif
+# endif
 #endif
     }
   else
@@ -1662,10 +1622,22 @@ static Image *ReadOnePNGImage(MngInfo *m
 
 #if defined(PNG_UNKNOWN_CHUNKS_SUPPORTED)
   /* Ignore unknown chunks */
+# if PNG_LIBPNG_VER < 10700 /* Avoid a libpng16 warning */
+  png_set_keep_unknown_chunks(ping, 2, NULL, 0);
+# else
   png_set_keep_unknown_chunks(ping, 1, NULL, 0);
-  /* Ignore unused chunks */
+# endif
+  /* Ignore unused chunks and all unknown chunks except for caNv */
+  png_set_keep_unknown_chunks(ping, 2, (png_bytep) mng_caNv, 1);
   png_set_keep_unknown_chunks(ping, 1, unused_chunks,
                               (int)sizeof(unused_chunks)/5);
+  /* Callback for other unknown chunks */
+  png_set_read_user_chunk_fn(ping, image, read_user_chunk_callback);
+#endif
+
+#ifdef PNG_READ_CHECK_FOR_INVALID_INDEX_SUPPORTED
+    /* Disable new libpng-1.5.10 feature while reading */
+    png_set_check_for_invalid_index (ping, 0);
 #endif
 
 #if defined(PNG_USE_PNGGCCRD) && defined(PNG_ASSEMBLER_CODE_SUPPORTED)  \
@@ -1687,47 +1659,105 @@ static Image *ReadOnePNGImage(MngInfo *m
 
   png_read_info(ping,ping_info);
 
+  (void) png_get_IHDR(ping,ping_info,
+                      &ping_width,
+                      &ping_height,
+                      &ping_bit_depth,
+                      &ping_colortype,
+                      &ping_interlace_method,
+                      &ping_compression_method,
+
+                      &ping_filter_method);
+
 #if (QuantumDepth == 8)
-  image->depth=8;
-#else
-  if (ping_info->bit_depth > 8)
+  if (ping_bit_depth > 8)
+  {
+#  if defined(PNG_READ_STRIP_16_TO_8_SUPPORTED) || \
+      defined(PNG_READ_16_TO_8_SUPPORTED)
+    png_set_strip_16(ping);
+#  else
+#    ifdef PNG_READ_SCALE_16_TO_8_SUPPORTED
+    png_set_scale_16(ping);
+#    endif
+#  endif
+    ping_bit_depth=8;
+    image->depth=8;
+  }
+#else /* QuantumDepth > 8 */
+  if (ping_bit_depth > 8)
     image->depth=16;
   else
     image->depth=8;
 #endif
 
-  if (ping_info->bit_depth < 8)
-    {
-      if ((ping_info->color_type == PNG_COLOR_TYPE_PALETTE))
-        {
-          png_set_packing(ping);
-          image->depth=8;
-        }
-    }
+  ping_file_depth = ping_bit_depth;
+
+  /* Save bit-depth and color-type in case we later want to write a PNG00 */
+  {
+      char
+        msg[MaxTextExtent];
+
+      (void) FormatString(msg,"%d",(int) ping_colortype);
+      (void) SetImageAttribute(image,"png:IHDR.color-type-orig",msg);
+
+      (void) FormatString(msg,"%d",(int) ping_bit_depth);
+      (void) SetImageAttribute(image,"png:IHDR.bit-depth-orig",msg);
+  }
+
+  (void) png_get_tRNS(ping, ping_info, &ping_trans_alpha, &ping_num_trans,
+                      &ping_trans_color);
+
+  (void) png_get_bKGD(ping, ping_info, &ping_background);
+
   if (logging)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG width: %lu, height: %lu",
-                            ping_info->width, ping_info->height);
+                            (unsigned long)ping_width,
+                            (unsigned long)ping_height);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG color_type: %d, bit_depth: %d",
-                            ping_info->color_type, ping_info->bit_depth);
+                            ping_colortype, ping_bit_depth);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG compression_method: %d",
-                            ping_info->compression_type);
+                            ping_compression_method);
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    PNG interlace_method: %d, filter_method: %d",
-                            ping_info->interlace_type,ping_info->filter_type);
+                            ping_interlace_method,
+                            ping_filter_method);
     }
 
-#if (PNG_LIBPNG_VER > 10008) && defined(PNG_READ_iCCP_SUPPORTED)
-  if (ping_info->valid & PNG_INFO_iCCP)
+  /* Too big? */
+  if (ping_width >
+    (magick_uint64_t) GetMagickResourceLimit(PixelsResource)/ping_height)
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+      "Number of pixels exceeds resource limit");
+    png_error(ping, "Number of pixels exceeds resource limit");
+  }
+
+  if (ping_bit_depth < 8)
+    {
+       png_set_packing(ping);
+       ping_bit_depth=8;
+       image->depth=8;
+    }
+
+#if defined(PNG_READ_iCCP_SUPPORTED)
+    if (png_get_valid(ping, ping_info, PNG_INFO_iCCP))
     {
       int
         compression;
 
+#if (PNG_LIBPNG_VER < 10500)
+      png_charp
+        info;
+#else
+      png_bytep
+        info;
+#endif
+
       png_charp
-        info,
         name;
 
       png_uint_32
@@ -1749,21 +1779,27 @@ static Image *ReadOnePNGImage(MngInfo *m
             }
         }
     }
-#endif /* #if (PNG_LIBPNG_VER > 10008) && defined(PNG_READ_iCCP_SUPPORTED) */
+#endif /* #if defined(PNG_READ_iCCP_SUPPORTED) */
 #if defined(PNG_READ_sRGB_SUPPORTED)
   {
     int
       intent;
 
-    if (mng_info->have_global_srgb)
-      image->rendering_intent=(RenderingIntent)
-        (mng_info->global_srgb_intent+1);
+    if (!png_get_sRGB(ping,ping_info,&intent))
+      {
+        if (mng_info->have_global_srgb)
+          {
+            png_set_sRGB(ping,ping_info,(mng_info->global_srgb_intent+1));
+          }
+      }
     if (png_get_sRGB(ping,ping_info,&intent))
       {
         image->rendering_intent=(RenderingIntent) (intent+1);
         if (logging)
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    Reading PNG sRGB chunk: rendering_intent: %d",intent+1);
+                                "    Reading PNG sRGB chunk:"
+                                " rendering_intent: %d",
+                                intent+1);
       }
   }
 #endif
@@ -1771,19 +1807,34 @@ static Image *ReadOnePNGImage(MngInfo *m
     double
       file_gamma;
 
-    if (mng_info->have_global_gama)
-      image->gamma=mng_info->global_gamma;
+    if (!png_get_gAMA(ping,ping_info,&file_gamma))
+      {
+        if (mng_info->have_global_gama)
+          png_set_gAMA(ping,ping_info,mng_info->global_gamma);
+      }
     if (png_get_gAMA(ping,ping_info,&file_gamma))
       {
         image->gamma=(float) file_gamma;
         if (logging)
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    Reading PNG gAMA chunk: gamma: %f",file_gamma);
+                                "    Reading PNG gAMA chunk: gamma: %f",
+                                file_gamma);
       }
   }
-  if (mng_info->have_global_chrm)
-    image->chromaticity=mng_info->global_chrm;
-  if (ping_info->valid & PNG_INFO_cHRM)
+  if (!png_get_valid(ping, ping_info, PNG_INFO_cHRM))
+    {
+      if (mng_info->have_global_chrm)
+        (void) png_set_cHRM(ping,ping_info,
+                     mng_info->global_chrm.white_point.x,
+                     mng_info->global_chrm.white_point.y,
+                     mng_info->global_chrm.red_primary.x,
+                     mng_info->global_chrm.red_primary.y,
+                     mng_info->global_chrm.green_primary.x,
+                     mng_info->global_chrm.green_primary.y,
+                     mng_info->global_chrm.blue_primary.x,
+                     mng_info->global_chrm.blue_primary.y);
+    }
+  if (png_get_valid(ping, ping_info, PNG_INFO_cHRM))
     {
       (void) png_get_cHRM(ping,ping_info,
                           &image->chromaticity.white_point.x,
@@ -1810,24 +1861,32 @@ static Image *ReadOnePNGImage(MngInfo *m
       image->chromaticity.white_point.x=0.3127f;
       image->chromaticity.white_point.y=0.3290f;
     }
-  if (mng_info->have_global_gama || image->rendering_intent)
-    ping_info->valid|=PNG_INFO_gAMA;
-  if (mng_info->have_global_chrm || image->rendering_intent)
-    ping_info->valid|=PNG_INFO_cHRM;
 #if defined(PNG_oFFs_SUPPORTED)
-  if (mng_info->mng_type == 0 && (ping_info->valid & PNG_INFO_oFFs))
+  if (mng_info->mng_type == 0 && (png_get_valid(ping, ping_info,
+                                                PNG_INFO_oFFs)))
     {
       image->page.x=png_get_x_offset_pixels(ping, ping_info);
       image->page.y=png_get_y_offset_pixels(ping, ping_info);
       if (logging)
         if (image->page.x || image->page.y)
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                "    Reading PNG oFFs chunk: x: %ld, y: %ld.",image->page.x,
+                                "    Reading PNG oFFs chunk: x: %ld, y: %ld.",
+                                image->page.x,
                                 image->page.y);
     }
 #endif
 #if defined(PNG_pHYs_SUPPORTED)
-  if (ping_info->valid & PNG_INFO_pHYs)
+  if (!png_get_valid(ping, ping_info, PNG_INFO_pHYs))
+    {
+      if (mng_info->have_global_phys)
+        {
+          png_set_pHYs(ping,ping_info,
+                       mng_info->global_x_pixels_per_unit,
+                       mng_info->global_y_pixels_per_unit,
+                       mng_info->global_phys_unit_type);
+        }
+    }
+  if (png_get_valid(ping, ping_info, PNG_INFO_pHYs))
     {
       int
         unit_type;
@@ -1851,28 +1910,14 @@ static Image *ReadOnePNGImage(MngInfo *m
         }
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Reading PNG pHYs chunk: xres: %lu, yres: %lu, units: %d.",
-                              x_resolution, y_resolution, unit_type);
-    }
-  else
-    {
-      if (mng_info->have_global_phys)
-        {
-          image->x_resolution=(float) mng_info->global_x_pixels_per_unit;
-          image->y_resolution=(float) mng_info->global_y_pixels_per_unit;
-          if (mng_info->global_phys_unit_type == PNG_RESOLUTION_METER)
-            {
-              image->units=PixelsPerCentimeterResolution;
-              image->x_resolution=(double)
-                mng_info->global_x_pixels_per_unit/100.0;
-              image->y_resolution=(double)
-                mng_info->global_y_pixels_per_unit/100.0;
-            }
-          ping_info->valid|=PNG_INFO_pHYs;
-        }
+                              "    Reading PNG pHYs chunk:"
+                              " xres: %lu, yres: %lu, units: %d.",
+                              (unsigned long)x_resolution,
+                              (unsigned long)y_resolution,
+                              unit_type);
     }
 #endif
-  if (ping_info->valid & PNG_INFO_PLTE)
+  if (png_get_valid(ping, ping_info, PNG_INFO_PLTE))
     {
       int
         number_colors;
@@ -1881,21 +1926,20 @@ static Image *ReadOnePNGImage(MngInfo *m
         palette;
 
       (void) png_get_PLTE(ping,ping_info,&palette,&number_colors);
-      if (number_colors == 0 && ping_info->color_type ==
+      if (number_colors == 0 && ping_colortype ==
           PNG_COLOR_TYPE_PALETTE)
         {
           if (mng_info->global_plte_length)
             {
               png_set_PLTE(ping,ping_info,mng_info->global_plte,
                            (int) mng_info->global_plte_length);
-              if (!(ping_info->valid & PNG_INFO_tRNS))
+              if (!(png_get_valid(ping, ping_info, PNG_INFO_tRNS)))
                 if (mng_info->global_trns_length)
                   {
                     if (mng_info->global_trns_length >
                         mng_info->global_plte_length)
-                      (void) ThrowException2(&image->exception,CoderError,
-                                             "global tRNS has more entries than global PLTE",
-                                             image_info->filename);
+                       png_error(ping, "global tRNS has more entries"
+                                             " than global PLTE");
                     png_set_tRNS(ping,ping_info,mng_info->global_trns,
                                  (int) mng_info->global_trns_length,NULL);
                   }
@@ -1904,7 +1948,7 @@ static Image *ReadOnePNGImage(MngInfo *m
 #ifndef PNG_READ_EMPTY_PLTE_SUPPORTED
                   mng_info->have_saved_bkgd_index ||
 #endif
-                  ping_info->valid & PNG_INFO_bKGD)
+                  png_get_valid(ping, ping_info, PNG_INFO_bKGD))
                 {
                   png_color_16
                     background;
@@ -1912,9 +1956,9 @@ static Image *ReadOnePNGImage(MngInfo *m
 #ifndef PNG_READ_EMPTY_PLTE_SUPPORTED
                   if (mng_info->have_saved_bkgd_index)
                     background.index=mng_info->saved_bkgd_index;
-                  else
 #endif
-                    background.index=ping_info->background.index;
+                  if (png_get_valid(ping, ping_info, PNG_INFO_bKGD))
+                    background.index=ping_background->index;
                   background.red=(png_uint_16)
                     mng_info->global_plte[background.index].red;
                   background.green=(png_uint_16)
@@ -1926,40 +1970,81 @@ static Image *ReadOnePNGImage(MngInfo *m
 #endif
             }
           else
-            (void) ThrowException2(&image->exception,CoderError,
-                                   "No global PLTE in file",image_info->filename);
+            png_error (ping, "No global PLTE in file");
         }
     }
 
 #if defined(PNG_READ_bKGD_SUPPORTED)
-  if (mng_info->have_global_bkgd && !(ping_info->valid & PNG_INFO_bKGD))
+  if (mng_info->have_global_bkgd &&
+              !(png_get_valid(ping,ping_info, PNG_INFO_bKGD)))
     image->background_color=mng_info->mng_global_bkgd;
-  if (ping_info->valid & PNG_INFO_bKGD)
+  if (png_get_valid(ping, ping_info, PNG_INFO_bKGD))
     {
       /*
         Set image background color.
       */
+
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "    Reading PNG bKGD chunk.");
-      if (ping_info->bit_depth <= QuantumDepth)
+
+      if (ping_bit_depth == QuantumDepth)
         {
-          image->background_color.red=ping_info->background.red;
-          image->background_color.green=ping_info->background.green;
-          image->background_color.blue=ping_info->background.blue;
+          image->background_color.red  = ping_background->red;
+          image->background_color.green= ping_background->green;
+          image->background_color.blue = ping_background->blue;
         }
-      else
+      else /* Scale background components to 16-bit */
         {
+          unsigned int
+            bkgd_scale;
+
+          if (logging != MagickFalse)
+            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "    raw ping_background=(%d,%d,%d).",ping_background->red,
+              ping_background->green,ping_background->blue);
+
+          bkgd_scale = 1;
+          if (ping_file_depth == 1)
+             bkgd_scale = 255;
+          else if (ping_file_depth == 2)
+             bkgd_scale = 85;
+          else if (ping_file_depth == 4)
+             bkgd_scale = 17;
+          if (ping_file_depth <= 8)
+             bkgd_scale *= 257;
+
+          ping_background->red *= bkgd_scale;
+          ping_background->green *= bkgd_scale;
+          ping_background->blue *= bkgd_scale;
+
+          if (logging != MagickFalse)
+            {
+            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "    bkgd_scale=%d.",bkgd_scale);
+            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "    ping_background=(%d,%d,%d).",ping_background->red,
+              ping_background->green,ping_background->blue);
+            }
+
           image->background_color.red=
-            ScaleShortToQuantum(ping_info->background.red);
+            ScaleShortToQuantum(ping_background->red);
           image->background_color.green=
-            ScaleShortToQuantum(ping_info->background.green);
+            ScaleShortToQuantum(ping_background->green);
           image->background_color.blue=
-            ScaleShortToQuantum(ping_info->background.blue);
+            ScaleShortToQuantum(ping_background->blue);
+          image->background_color.opacity=OpaqueOpacity;
+
+          if (logging != MagickFalse)
+            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "    image->background_color=(%d,%d,%d).",
+              image->background_color.red,
+              image->background_color.green,image->background_color.blue);
         }
     }
 #endif
-  if (ping_info->valid & PNG_INFO_tRNS)
+
+  if (png_get_valid(ping, ping_info, PNG_INFO_tRNS))
     {
       int
         bit_mask;
